//---------------------------------------------------------------------------

#ifndef SignalH
#define SignalH
//---------------------------------------------------------------------------

#include <vector>
#include <string>

class Signal
{
private:
	float fData[1024*1024];
	short data[1024*1024];
public:
	Signal();
	enum { SHAPE_CNT = 16 };
	enum E_WAVEFORM
	{
		//WAVE_NONE = 0,
		//WAVE_DC,
		WAVE_SINUS = 0,
		WAVE_SQUARE,
		WAVE_NOISE,
		WAVE_TRIANGLE,
		WAVE_SAWTOOTH,
		WAVE_SAWTOOTH_REV,
		WAVE_LIMITER
	};

	float fAmplitude;
	float fOffset;
	enum E_WAVEFORM shape;

	/** \brief Generate samples
		\param shape vector of waveforms
		\param count requested samples count
		\param fDivX sampling time
		\param fDivY voltage per bit
		\return pointer to data vector, NULL on error
	*/
	short* Generate(unsigned int count, float fDivY);
	static int GetTypeDescription(int type, std::string &desc);
};

#endif
