//---------------------------------------------------------------------------

#ifndef SignalSynthCfgH
#define SignalSynthCfgH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

#include <vector>
#include "Signal.h"

class Signal;

class TfrmSignalSynthConfig : public TForm
{
__published:	// IDE-managed Components
	TPanel *pnlDetailView;
	TLabel *lblWaveType;
	TLabel *lblAmplitude;
	TLabel *lblFrequency;
	TComboBox *cbWaveType;
	TEdit *edAmplitude;
	TEdit *edFrequency;
	TButton *btnApply;
	TLabel *Label1;
	TEdit *edOffset;
	TLabel *Label2;
	TEdit *edRealFreq;
	void __fastcall btnApplyClick(TObject *Sender);
	void __fastcall edFrequencyChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
private:	// User declarations
	Signal signal;
	int period;
	bool confirmed;
	float GetRealFreq(float reqFreq);
public:		// User declarations
	__fastcall TfrmSignalSynthConfig(TComponent* Owner);
	float fBaseSamplingFreq;
	int iMaxSamples;
	short* Generate(float fDivY, int& count);
	bool Confirmed(void) {
    	return confirmed;
	}
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmSignalSynthConfig *frmSignalSynthConfig;
//---------------------------------------------------------------------------
#endif
