//---------------------------------------------------------------------------

#ifndef ThreadCommH
#define ThreadCommH
//---------------------------------------------------------------------------
#include <deque>
#include "Mutex.h"
#include "Fifo.h"
//---------------------------------------------------------------------------

extern TCriticalSection *SC;
extern struct usb_dev_handle *usb_handle;
extern bool writeLock;
extern int regIdx;

class ThreadComm
{
private:
	typedef void (*CallbackLog)(char*);
	typedef void (*CallbackData)(short*, int);
	typedef void (*CallbackConnect)(int, char*);
	Mutex mutexSend;
	bool bContinuousTrigger;

	friend DWORD WINAPI ThreadCommProc(LPVOID data);
	friend DWORD WINAPI ThreadRxQueueProc(LPVOID data);
	FIFO rxFifo;
	typedef void (__closure *CallbackDataRcv)(unsigned char *data, unsigned int len);


protected:
public:
	enum { E_USB_FRAME_SIZE = 4096 };
	bool connected;
   	CallbackLog callbackLog;
	CallbackDataRcv callbackDataRcv;
	CallbackConnect callbackConnect;
	__fastcall ThreadComm();

	HANDLE Thread;
	HANDLE ThreadRxQueue;
	void Execute();

	enum { CMD_SIZE = 64 };
	struct Cmd {
		unsigned char buffer[64];
	};	
	/** \brief Send command to armscope device
		\return zero on success
	*/
	int SendCmd(struct Cmd &cmd);
	void log(char *lpData, ...);

private:
	std::deque<struct Cmd> que_cmd;
};
//---------------------------------------------------------------------------
#endif
